/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++

ƌfpvOilʑ̂̏dSוƂQdSוj

lʑ̂̏dSוƁClʑ̂̂QdSו\

eɂĂ̓vOQCRQƂĂ

++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
#include <LEDA/window.h>
#include <LEDA/d3_hull.h>
#include <LEDA/d3_window.h>
#include <LEDA/random_rat_point.h>
#include <stdio.h>
#include <LEDA/d3_delaunay.h>
#include <LEDA/d3_point.h>
#include <LEDA/graphwin.h>
#include <LEDA/d3_ray.h>
#include <LEDA/d3_simplex.h>
#include <LEDA/d3_line.h>
#include <LEDA/d3_segment.h>
#include <LEDA/triangle.h>
#include <LEDA/d3_sphere.h>
#include <LEDA/graph_alg.h>

using namespace leda;
using std::cin;
using std::cout;
using std::endl;
using leda::string;

void rmove_triangle(GRAPH<d3_rat_point,int>& );

void creat_knot(GRAPH<d3_rat_point,int>& ,list<d3_rat_point>& );

void input_point(GRAPH<d3_rat_point,int>& ,list<d3_rat_point>& ,list<d3_rat_point>& );

void list_tetora(GRAPH<d3_rat_point,int>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& );

void binary_subdivision(list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& );



int compare_knot(list<d3_rat_point>& ,d3_rat_point ,d3_rat_point ,d3_rat_point ,d3_rat_point );

void append_point(list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,list<d3_rat_point>& ,d3_rat_point ,d3_rat_point ,d3_rat_point ,d3_rat_point );

void create_graph(GRAPH<d3_rat_point,int>& , list<d3_rat_point>& , list<d3_rat_point>& , list<d3_rat_point>& , list<d3_rat_point>& );

window W(800,800,"UWF INTER SONE");

int main(){

  int a,k;
  node v;

  list<d3_rat_point> DTL,LK;
  list<d3_rat_point> A1,A2,A3,A4;
  list<d3_rat_point> B1,B2,B3,B4;
  list<d3_rat_point> C1,C2,C3,C4;

  GRAPH<d3_rat_point,int> DTG,G1,G2,G3,G4,knot;
 

  //random_d3_rat_points_in_ball(4,110,LK);
  
  
  d3_rat_point p1(0,0,80);
  d3_rat_point p2(70,70,0);
  d3_rat_point p3(0,-60,0);
  d3_rat_point p4(-70,70,0);

  LK.append(p1);
  LK.append(p2);
  LK.append(p3);
  LK.append(p4);
  

  creat_knot(knot,LK);/*іڂOt*/

  d3_rat_point dp;
  forall(dp,LK){
    printf("DTLX is %f\n",dp.xcoordD());
    printf("DTLY is %f\n",dp.ycoordD());
    printf("DTLZ is %f\n\n",dp.zcoordD());
  }

  //random_d3_rat_points_in_ball(a,120,DTL);

  input_point(knot,DTL,LK);
  
  D3_DELAUNAY(DTL,DTG);

  rmove_triangle(DTG);

  list_tetora(DTG,A1,A2,A3,A4);
  
  binary_subdivision(A1,A2,A3,A4,B1,B2,B3,B4);

  binary_subdivision(B1,B2,B3,B4,C1,C2,C3,C4);
  
 
 
 create_graph(G1,C1,C2,C3,C4);
 create_graph(G2,B1,B2,B3,B4);
 
 W.set_bg_color(black);
 W.init(-110,110,-110);
 W.display(0,0);
 
 
 node_array<rat_vector> pos1(G1);
 forall_nodes(v,G1) pos1[v]=G1[v].to_vector();
 
 node_array<rat_vector> pos2(G2);
 forall_nodes(v,G2) pos2[v]=G2[v].to_vector();

 
  d3_window d3win(W,G2,pos2);
  d3win.set_draw_graph(true);
  d3win.set_speed(10);
  d3win.set_message
    ("\\bf\\white left:  \\green zoom up   ~~~~~\
     \\bf\\white middle:\\green zoom down ~~~~~\
     \\bf\\white right: \\green exit");
  d3win.set_node_color(cyan);
  d3win.set_edge_color(white);
  d3win.set_node_width(7);
  d3win.draw();     
  int but = 0;   
  while (but != MOUSE_BUTTON(3)) but = d3win.move();
  
  d3_window d3win3(W,G1,pos1);

  d3win3.set_draw_graph(true);
  d3win3.set_speed(10);
  d3win3.set_message
    ("\\bf\\white left:  \\green zoom up   ~~~~~\
     \\bf\\white middle:\\green zoom down ~~~~~\
     \\bf\\white right: \\green exit");
  d3win3.set_node_color(cyan);
  d3win3.set_edge_color(white);
  d3win3.set_node_width(7);
  d3win3.draw();     
  but = 0;   
  while (but != MOUSE_BUTTON(3)) but = d3win3.move();

 

  W.read_mouse();	
  return 0;
}



void rmove_triangle(GRAPH<d3_rat_point,int>& G){

  node v;
  list<node> rm_L;

  forall_nodes(v,G){

    if(G.degree(v)==4){
      rm_L.append(v);
    }
  }

  forall(v,rm_L){

    node rmv=v;
    G.del_node(rmv);
  }
}


void list_tetora(GRAPH<d3_rat_point,int>& G ,list<d3_rat_point>& H1,list<d3_rat_point>& H2,list<d3_rat_point>& H3,list<d3_rat_point>& H4){

  node v;
  int i=0;

  forall_nodes(v,G){

    if(i==0){
      node v1=v;
      H1.append(G[v1]);
      i++;
    }

    else if(i==1){
      node v2=v;
      H2.append(G[v2]);
      i++;
    }

    else if(i==2){
      node v3=v;
      H3.append(G[v3]);
      i++;
    }

    else{
      node v4=v;
      H4.append(G[v4]);
      i=0;
    }
  }
}

void binary_subdivision(list<d3_rat_point>& H1,list<d3_rat_point>& H2,list<d3_rat_point>& H3,list<d3_rat_point>& H4,list<d3_rat_point>& I1,list<d3_rat_point>& I2,list<d3_rat_point>& I3,list<d3_rat_point>& I4){

  d3_point p;
  int i,list_size;

  i=0;
  list_size=H1.size();

  while(i<list_size){

    d3_rat_point p1=H1[H1.get_item(i)];
    d3_rat_point p2=H2[H2.get_item(i)];
    d3_rat_point p3=H3[H3.get_item(i)];
    d3_rat_point p4=H4[H4.get_item(i)];


    d3_rat_point ggp (((p1.xcoord()+p2.xcoord()+p3.xcoord()+p4.xcoord())/4),((p1.ycoord()+p2.ycoord()+p3.ycoord()+p4.ycoord())/4),((p1.zcoord()+p2.zcoord()+p3.zcoord()+p4.zcoord())/4));

    d3_rat_point gp1(((p1.xcoord()+p2.xcoord()+p3.xcoord())/3),((p1.ycoord()+p2.ycoord()+p3.ycoord())/3),((p1.zcoord()+p2.zcoord()+p3.zcoord())/3));


    d3_rat_point gp2(((p1.xcoord()+p2.xcoord()+p4.xcoord())/3),((p1.ycoord()+p2.ycoord()+p4.ycoord())/3),((p1.zcoord()+p2.zcoord()+p4.zcoord())/3));

    d3_rat_point gp3(((p1.xcoord()+p3.xcoord()+p4.xcoord())/3),((p1.ycoord()+p3.ycoord()+p4.ycoord())/3),((p1.zcoord()+p3.zcoord()+p4.zcoord())/3));

 d3_rat_point gp4(((p2.xcoord()+p3.xcoord()+p4.xcoord())/3),((p2.ycoord()+p3.ycoord()+p4.ycoord())/3),((p2.zcoord()+p3.zcoord()+p4.zcoord())/3));


 d3_rat_point Mp12=midpoint(p1,p2);
 d3_rat_point Mp13=midpoint(p1,p3);
 d3_rat_point Mp14=midpoint(p1,p4);
 d3_rat_point Mp23=midpoint(p2,p3);
 d3_rat_point Mp24=midpoint(p2,p4);
 d3_rat_point Mp34=midpoint(p3,p4);

 ///////////////////////////////////////

 append_point(I1,I2,I3,I4,ggp,gp1,Mp12,p1);
 append_point(I1,I2,I3,I4,ggp,gp1,Mp12,p2);
 append_point(I1,I2,I3,I4,ggp,gp1,Mp13,p1);
 append_point(I1,I2,I3,I4,ggp,gp1,Mp13,p3);
 append_point(I1,I2,I3,I4,ggp,gp1,Mp23,p2);
 append_point(I1,I2,I3,I4,ggp,gp1,Mp23,p3);

 append_point(I1,I2,I3,I4,ggp,gp2,Mp12,p1);
 append_point(I1,I2,I3,I4,ggp,gp2,Mp12,p2);
 append_point(I1,I2,I3,I4,ggp,gp2,Mp14,p1);
 append_point(I1,I2,I3,I4,ggp,gp2,Mp14,p4);
 append_point(I1,I2,I3,I4,ggp,gp2,Mp24,p2);
 append_point(I1,I2,I3,I4,ggp,gp2,Mp24,p4);

 append_point(I1,I2,I3,I4,ggp,gp3,Mp13,p1);
 append_point(I1,I2,I3,I4,ggp,gp3,Mp13,p3);
 append_point(I1,I2,I3,I4,ggp,gp3,Mp14,p1);
 append_point(I1,I2,I3,I4,ggp,gp3,Mp14,p4);
 append_point(I1,I2,I3,I4,ggp,gp3,Mp34,p3);
 append_point(I1,I2,I3,I4,ggp,gp3,Mp34,p4);

 append_point(I1,I2,I3,I4,ggp,gp4,Mp23,p2);
 append_point(I1,I2,I3,I4,ggp,gp4,Mp23,p3);
 append_point(I1,I2,I3,I4,ggp,gp4,Mp24,p2);
 append_point(I1,I2,I3,I4,ggp,gp4,Mp24,p4);
 append_point(I1,I2,I3,I4,ggp,gp4,Mp34,p3);
 append_point(I1,I2,I3,I4,ggp,gp4,Mp34,p4);

 /////////////////////////////////////////

 i++;
  }
}

void append_point(list<d3_rat_point>& X1,list<d3_rat_point>& X2,list<d3_rat_point>& X3,list<d3_rat_point>& X4,d3_rat_point x1,d3_rat_point x2,d3_rat_point x3,d3_rat_point x4){

  X1.append(x1);
  X2.append(x2);
  X3.append(x3);
  X4.append(x4);
}


void create_graph(GRAPH<d3_rat_point,int>& G , list<d3_rat_point>& X1, list<d3_rat_point>& X2, list<d3_rat_point>& X3, list<d3_rat_point>& X4){

  int i=0;
  int list_size;

  node v1,v2,v3,v4;

  list_size=X1.size();

  while(i<list_size){

    v1=G.new_node();
    G[v1]=X1[X1.get_item(i)];

    v2=G.new_node();
    G[v2]=X2[X2.get_item(i)];

    v3=G.new_node();
    G[v3]=X3[X3.get_item(i)];

    v4=G.new_node();
    G[v4]=X4[X4.get_item(i)];

    G.new_edge(v1,v2);
    G.new_edge(v1,v3);
    G.new_edge(v1,v4);
    G.new_edge(v2,v3);
    G.new_edge(v2,v4);
    G.new_edge(v3,v4);

    i++;
  }
}

void creat_knot(GRAPH<d3_rat_point,int>& knot,list<d3_rat_point>& LK){

  d3_rat_point p;
  list<node> N;
  node v,x1,x2,x3,x4;
  int L_size,i=0;

  forall(p,LK){
    node v1=knot.new_node();
    knot[v1]=p;
  }

  // N.sort();

  forall_nodes(v,knot){
    N.append(v);
  }
  
  x1=N[N.get_item(0)];
  x2=N[N.get_item(1)];
  x3=N[N.get_item(2)];
  x4=N[N.get_item(3)];
      
 

      knot.new_edge(x1,x2);
      knot.new_edge(x2,x1);
      knot.new_edge(x1,x3);
      knot.new_edge(x3,x1);
      knot.new_edge(x1,x4);
      knot.new_edge(x4,x1);
      knot.new_edge(x2,x3);
      knot.new_edge(x3,x2);
      knot.new_edge(x2,x4);
      knot.new_edge(x4,x2);
      knot.new_edge(x3,x4);
      knot.new_edge(x4,x3);
  
}

void input_point(GRAPH<d3_rat_point,int>& knot2,list<d3_rat_point>& L,list<d3_rat_point>& LK){

  d3_rat_point p;

  forall(p,L){
    node v1=knot2.new_node();
    knot2[v1]=p;
  }

  forall(p,LK){
    L.append(p);
  }
}
